#include "globals.h"
#include "functions.h"

int parse_condition()
{
char token[TOKENSIZE];
int tokentype;
char newtoken[LINELENGTH];

  putc('(',out);

  while((tokentype=gettoken(token))!=5 && tokentype!=3)
  {
    if (tokentype==0) { return 1; }

    if (tokentype==6)
    { break; }
      else
    if (tokentype==7)
    { putc('+',out); }
      else
    if (tokentype==3)
    { putc('\n',out); continue; }
      else
    if (strcasecmp(token,"not")==0)
    { fprintf(out,"!"); }
      else
    if (strcasecmp(token,"and")==0)
    { fprintf(out," && "); }
      else
    if (strcasecmp(token,"then")==0 || tokentype==5)
    { break; }
      else
    if (strcasecmp(token,"=")==0)
    { fprintf(out,"=="); }
      else
    if (strcasecmp(token,"<>")==0)
    { fprintf(out,"!="); }
      else
    if (strcasecmp(token,"or")==0)
    { fprintf(out," || "); }
      else
    if (tokentype==10 || tokentype==11)
    { fprintf(out,"%s",token); }
      else
    if (tokentype==9)
    { putc('.',out); }
      else
    if (tokentype==12 || tokentype==8)
    { fprintf(out,"%s",token); }
      else
    if (tokentype==1)
    { fprintf(out,"%s",token); }
      else
    if (tokentype==2)
    {
      eval_element(newtoken, tokentype, token);
      fprintf(out,"%s",newtoken);
    }
/*
    if (tokentype==2 && iskeyword(token)==0)
    { fprintf(out,"$%s",token); }
      else
    { fprintf(out,"%s",token); }
*/
  } 
  fprintf(out,")");
  strcpy(tokenpush,token);
  tokentypepush=tokentype;

/* 
  if (tokentype==5)
  { putc('\n',out); }
    else
  if (tokentype==6) 
  {
    fprintf(out,"?>");
    copyhtml();
  } 
*/
}

int parse_select()
{
char token[TOKENSIZE];
char newtoken[LINELENGTH];
int t,c,tokentype;

  tokentype=gettoken(token);
  if (strcasecmp(token,"case")!=0)
  { error(token,"case","Select"); }

  autoindent();
  fprintf(out,"switch ");
  c=parse_condition();
  putc('\n',out);
  autoindent();
  fprintf(out,"{\n");
  indent++;
  
  while(1)
  {
    tokentype=gettoken(token);
    if (tokentype==5 || tokentype==13)
    { continue; }
      else
    if (tokentype==0 || strcasecmp(token,"end")==0)
    { break; }
      else
    if (strcasecmp(token,"case")!=0)
    { error(token,"case","Select"); }

    while (1)
    {
      autoindent();
      fprintf(out,"case ");
      while (1)
      {
        tokentype=gettoken(token);
        if (tokentype==5 || tokentype==13)
	{ break; }
	  else
	if (strcmp(token,",")==0)
	{ break; }
	  else
        if (tokentype!=2)
        { fprintf(out,"%s",token); }
          else
        if (iskeyword(token)==1)
        { eval_token(tokentype,token); }
	  else
        if (isfunction(token)==1)
        {
    	  fprintf(out,"%s",token);
    	  t=gettoken(token);
    	  if (strcmp(token,"(")==0)
    	  {
      	    sprintf(newtoken,"(");
      	    strcpy(tokenpush,"(");
      	    tokentypepush=tokentype;
      	    eval_funct(newtoken);
	    strcat(newtoken,")");
    	  }
      	    else
    	  { error(token,"(","Select"); }
        }
          else
        { fprintf(out,"$%s",token); }
      }
      fprintf(out,":\n");

      if (tokentype==5 || tokentype==13)
      { break; }
    }
    indent++;
    parse_body(0);
    autoindent();
    fprintf(out,"break;\n");
    indent--;

    tokentype=gettoken(token);
    if (strcasecmp(token,"select")==0)
    { break; }

    strcpy(tokenpush,token);
    tokentypepush=tokentype;
  }

  indent--;
  autoindent();
  fprintf(out,"} ");
}

int parse_if()
{
char token[255];
int tokentype;
int c;

  autoindent();
  fprintf(out,"if ");
  c=parse_condition();
  c=gettoken(token);
  fprintf(out,"\n");
  autoindent();
  fprintf(out,"{\n");
  indent++;

  tokentype=gettoken(token);
  tokentypepush=tokentype;
  strcpy(tokenpush,token);

  if (tokentype==5 || tokentype==6)
  { c=parse_body(0); }
    else
  { c=parse_body(1); }

  indent--;
  autoindent();
  fprintf(out,"} ");
  tokentype=gettoken(token);

  if (strcasecmp(token,"if")!=0)
  {
    tokentypepush=tokentype;
    strcpy(tokenpush,token);
    // printf("Parse Error: Expected End If?\n");
  }

  tokentype=gettoken(token);
  tokentypepush=tokentype;
  strcpy(tokenpush,token);

  if (tokentype!=6)
  { fprintf(out,"\n"); }
}



