
/* General */ 
extern void push(char *token, int tokentype); 
extern void error(char *token,char *expected, char *keyword); 
extern int isnum(char *s);
extern char *strcasestr(char *hejstack, char *needle);
extern void insert_session();
extern void insert_isnum();
extern int getobject(char *token);
extern int autoindent();
extern int parse_tag();
extern int gettoken();

/* HTML */

extern int parse_tag();
extern int copyhtml();

/* Token evaluation */

extern int eval_element(char *newtoken, int tokentype, char *token);

/* DataBase */

extern int db_open(char *newtoken, char *variable);
extern int db_execute(char *newtoken, char *variable);
extern int parse_adodb_rs(char *newtoken,char *variable);
extern int parse_adodb_connection(char *newtoken,char *variable);
extern int getvar(char *answer, char *token, char *variable);

/* Sessions */

extern int parse_session();

/* Loops */

extern void start_session();
extern int parse_do_loop();
extern int parse_while();
extern int parse_for();

/* Conditionals */

extern int parse_if();
extern int parse_select();
extern int parse_condition();




