#include "globals.h"
#include "functions.h"

int parse_do_loop()
{
char token[TOKENSIZE];
int c;

  autoindent();
  fprintf(out,"do\n");
  autoindent();
  fprintf(out,"{\n");
  indent++;
  parse_body(0);
  indent--;
  c=gettoken(token);
  if (strcasecmp("until",token)!=0)
  { error(token,"Until","Do"); }
  autoindent();
  fprintf(out,"} while (!");
  c=parse_condition();
  fprintf(out,");\n");
}

int parse_while()
{
char token[TOKENSIZE];
int c;

  autoindent();
  fprintf(out,"while");
  c=parse_condition();
  fprintf(out,"\n");
  autoindent();
  fprintf(out,"{\n");
  indent++;
  c=parse_body(0);
  indent--;
  autoindent();
  fprintf(out,"} ");
}

int parse_for()
{
char token[TOKENSIZE];
char variable[TOKENSIZE];
char expression[LINELENGTH];
char newtoken[LINELENGTH];
int c,tokentype;
int step=0;

  gettoken(token);
  strcpy(variable,token);
  autoindent();
  fprintf(out,"for ($%s",variable);

  eval_expression(" ");
  fprintf(out,"; ");
  sprintf(expression,"");

  while(1)
  {
    tokentype=gettoken(token);

    if (tokentype==0)
    { printf("Parse error: End of file reached early on line %d\n",line); return; }
      else
    if (strcasecmp("step",token)==0 || (tokentype==13 || tokentype==5))
    { break; }
      else
    {
      strcpy(newtoken,"");
      eval_element(newtoken,tokentype,token);
      strcat(expression,newtoken);
    }
/*
      else
    if (tokentype==2 && iskeyword(token))
    { eval_keyword(token); printf("uh oh.. this ain't quite supported.. email: naken@i1.net and report your code\n");  }
      else
    if (tokentype==2)
    {
      strcat(expression,"$");
      strcat(expression,token);
    }
      else
    { strcat(expression,token); } 
*/
  }

  if (strcasecmp(token,"step")==0)
  {
    tokentype=gettoken(token);
    if (strcmp("-",token)==0)
    { step=-1; }
      else
    { strcpy(tokenpush,token); tokentypepush=tokentype; step=1; }
  }

  if (step==1 || step==0)
  { fprintf(out,"$%s<=%s; $%s=$%s+",variable,expression,variable,variable); }
    else
  if (step==-1)
  { fprintf(out,"$%s>=%s; $%s=$%s-",variable,expression,variable,variable); }

  if (step==0)
  { putc('1',out); }
    else
  { 
/*
    if (step==1)
    {
      if (tokentype==2 && iskeyword(token))
      { printf("Not implemented. Email naken@i1.net\n"); } 
        else
      if (tokentype==2)
      { fprintf(out,"$%s",token); }
        else
      { fprintf(out,"%s",token); }
    }
*/

    while(1)
    {
      tokentype=gettoken(token);

      if (tokentype==5 || tokentype==13)
      { break; }
	else
      if (tokentype==0)
      { error(token,"?","For"); return; }
        else
      if (tokentype==2 && iskeyword(token))
      { eval_keyword(token); printf("uh oh.. this ain't quite supported.. email: naken@i1.net and report your code\n");  }
        else
      if (tokentype==2)
      { fprintf(out,"$%s",token); }
        else
      { fprintf(out,"%s",token); } 
    }
  }

  fprintf(out,")\n");
  autoindent();
  fprintf(out,"{\n");
  indent++;
  c=parse_body(0);
  indent--;

  if (column!=0)
  { putc('\n',out); column=0; }

  autoindent();
  fprintf(out,"} ");

  tokentype=gettoken(token);
  tokentypepush=tokentype;
  strcpy(tokenpush,token);

  if (tokentype!=6) putc('\n',out);
}
