#include "globals.h"
#include "functions.h"

/* parse_tag() will change occurances of .asp to .php3 and
   change .htm to .html */

int parse_tag()
{
int ch,lastchar;
int count=0;
char extension[10];

  while((ch=getc(in))!=EOF)
  {
    lastchar=ch;
    if (!((ch>='a' && ch<='z') || (ch>='A' && ch<='Z')) || count>3)
    {
      extension[count]=0;
      break;
    }
    extension[count++]=ch;
  }

  if (strcasecmp(extension,"htm")==0)
  { strcpy(extension,"html"); }
    else
  if (strcasecmp(extension,"asp")==0)
  { strcpy(extension,"php3"); }
    else
  if (strcasecmp(extension,"gif")==0 && pngs==1)
  { strcpy(extension,"png"); }

  fprintf(out,"%s",extension);
  putc(lastchar,out);
}

/* copyhtml() will simply copy html code straight */

int copyhtml()
{
int ch,lastchar=-1;
int carret=0,quote=0;

  while((ch=getc(in))!=EOF)
  {
    if (ch=='\n' && carret==0) line++;
      else
    if (carret==1 && ch!='\n')
    { carret=0; column=0; }
      else
    if (carret==1 && ch=='\n')
    { continue; }

    carret=0;

    if (ch=='\r')
    { 
      if (lastchar!=-1) putc(lastchar,out); 
      putc('\n',out); 
      lastchar=-1;
      carret=1; 
      line++; 
      column=0; 
      continue; 
    }

    column++;

    if (lastchar=='<' && ch=='%')
    {
      putc('<',out);
      putc('?',out);
      putc(' ',out);
      return 0;
    }
      else
    if ((ch=='\'' || ch=='\"') && lastchar!='\\')
    {
      if (ch==quote)
      { quote=0; }
        else
      { quote=ch; }
    }

    if (quote!=0)
    {
      if ((ch==' ' || ch=='\t') || (ch=='\r' || ch=='\n'))
      { quote=0; line++; }
        else
      if (ch=='.')
      { 
	putc(lastchar,out);
	putc('.',out);
	parse_tag();
	lastchar=-1;
	continue;
      }
    }

    if (lastchar!=-1)
    { putc(lastchar,out); }
    lastchar=ch;
  }

  if (lastchar!=-1) putc(lastchar,out);
  return 1;
}

